 /*
  * Khoros: $Id: vmcdilate.c,v 1.1 1991/05/10 15:48:31 khoros Exp $
  */

#if !defined(lint) && !defined(SABER)
static char rcsid[] = "Khoros: $Id: vmcdilate.c,v 1.1 1991/05/10 15:48:31 khoros Exp $";
#endif

 /*
  * $Log: vmcdilate.c,v $
 * Revision 1.1  1991/05/10  15:48:31  khoros
 * Initial revision
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */

/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: vmcdilate.c
 >>>>
 >>>>      Program Name: vmcdilate
 >>>>
 >>>>      Program Desc: 
 >>>>	
 >>>>	Conditionally  dilate  a  binary  image  by  a   structuring
 >>>>	element.
 >>>>	
 >>>>	
 >>>>            Author: Pascal Adam
Greg Donohoe
 >>>>
 >>>> Date Last Updated: Tue Mar  5 22:30:24 1991
 >>>>
 >>>>          Routines: main- the main program for vmcdilate
 >>>> 		 gw_usage - gives usage of the program
 >>>> 		 gw_args  - gets arguments of program from command line
 >>>>
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/


#include "vmcdilate.h"


/****************************************************************
 *
 * Routine Name:  main program for vmcdilate
 *
 *       Input:  
 *           -i  input image 
 *           -k  input kernel 
 *           -o  output image 
 *
 *
 *           [-f] foreground value  (0 < value < 255)
 *           [-w] wave value  (0 < value < 255)
 *
 *
 *
 ****************************************************************/


main(argc, argv)
int argc;
char *argv[];
{

/* -main_variable_list */
struct xvimage *image, *kernel,*readimage();
/* -main_variable_list_end */

	program = VStrcpy(argv[0]);
	ac = argc;
	av = argv;

	khoros_init();

	gw_get_args();

/* -main_before_lib_call */

   if (check_args()) exit(1);

   READINPUT(image,kernel) ;
   CHECKINPUT(program, image, kernel) ;

   if (!(vmcdilate->w_flag))
        vmcdilate->w_int = vmcdilate->f_int;

/* -main_before_lib_call_end */

/* -main_library_call */

   if(! lvmcdilate(image,kernel,vmcdilate->f_int,vmcdilate->w_int))
   {
      (void) fprintf(stderr, "vmcdilate: lvmcdilate Failed\n");
      exit(1);
   }


/* -main_library_call_end */

/* -main_after_lib_call */
   writeimage(vmcdilate->o_file,image);
/* -main_after_lib_call_end */


	khoros_close();
}


/****************************************************************
*
* Routine Name:  gw_usage 
*
*
* Purpose:  prints out the usage for vmcdilate 
*
* Input:  none 
*
* Output:  none 
*
* Written By:  automatically generated by ghostwriter
*
****************************************************************/


gw_usage()
{
	fprintf(stderr, "vmcdilate :\n");
	fprintf(stderr, "\t\n");
	fprintf(stderr, "\tConditionally  dilate  a  binary  image  by  a   structuring\n");
	fprintf(stderr, "\telement.\n");
	fprintf(stderr, "\t\n");
	fprintf(stderr, "\t\n");

/* -usage_additions */
/* -usage_additions_end */

	fprintf(stderr,"\t-i  input image  (infile)\n");
	fprintf(stderr,"\t-k  input kernel  (infile)\n");
	fprintf(stderr,"\t-o  output image  (outfile)\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "\n");
	fprintf(stderr,"\t[-f]  foreground value (integer, 0 to 255) [255]\n");
	fprintf(stderr,"\t[-w]  wave value (integer, 0 to 255) [255]\n");
	fprintf(stderr, " \n");
	fprintf(stderr, "\n");
	fprintf(stderr, "\t[-V] Gives the version for vmcdilate\n");
	fprintf(stderr, "\t[-U] Gives the usage for vmcdilate\n");
	fprintf(stderr, "\t[-P] Prompts for command line options\n");
	fprintf(stderr, "\t[-A [file1]] Creates the answer file called vmcdilate.ans or file1 \n");
	fprintf(stderr, "\t[-a [file1]] Uses vmcdilate.ans or file1 as the answer file \n\n\n");

}


/****************************************************************
*
* Routine Name:  gw_getargs 
*
*
* Purpose:  gets arguments off command line for vmcdilate
*
* Input:  none 
*
* Output:  none 
*
* Written By:  automatically generated by ghostwriter
*
****************************************************************/


gw_get_args()
{

char	*i_pstr = 
	"\nEnter: (i) input image \n        {infile}: "; 
char	*k_pstr = 
	"\nEnter: (k) input kernel \n        {infile}: "; 
char	*o_pstr = 
	"\nEnter: (o) output image \n        {outfile}: "; 
char	*f_pstr = 
	"\nEnter: (f) foreground value \n        {integer, 0 to 255 [255] }: "; 
char	*w_pstr = 
	"\nEnter: (w) wave value \n        {integer, 0 to 255 [255] }: "; 
char  answer_file[512], temp[512];



int	fid = -1,
	error, query, ok, count;
	int prompt_flag = FALSE;

	/*
	 * print version if necessary
	 */
	vgparml(fid, "-V", "noprompt", &query, 0, 0, &error);
	if (error == 0)
	{
	    printf ("\n%s: %s: Version %d.%d\n\n",
	    "vmcdilate", RELEASE_NAME, RELEASE_MAJOR, RELEASE_MINOR);
	    exit(1);
	}

	/*
	 * print usage if necessary
	 */
	vgparml(fid, "-U", "noprompt", &query, 0, 0, &error);
	if (error == 0)
	{
	    gw_usage();
	    exit(1);
	}

	/*
	 * see if interactive prompting is desired
	 */
	vgparml(fid, "-P", "noprompt", &query, 0, 0, &error);
	if (error == 0)
	    prompt_flag = TRUE;

	/*
	 * see if answer file is to be used
	 */
	vgparms(fid, "-a", "noprompt", answer_file, 0, 0, &error);
	if (error == 0)
	{
	     if (VStrlen(answer_file) == 0)
		sprintf(answer_file, "vmcdilate.ans");
	     while (fid < 0)
	     {
		if ((fid = open(answer_file, O_RDONLY, 0666))== -1)
		{
		    fprintf(stderr, "vmcdilate: can't open answer file \"%s\"",
			    answer_file); 
		    fprintf(stderr, "please re-enter: ");
		    (void) gets(answer_file);
		    if (VStrlen(answer_file) == 0)
			sprintf(answer_file, "vmcdilate.ans");
		}

	     }

	}

	/*
	 * allocate the vmcdilate structure
	 */
	vmcdilate = (vmcdilate_struct *) 
	       calloc((unsigned)1, (unsigned) sizeof (vmcdilate_struct));

	/*
	 * get required arguments for vmcdilate
	 */
	if (prompt_flag == TRUE)
	    fprintf(stderr,"\nRequired Arguments:\n\n");

	if (!(vmcdilate->i_flag = vget_infile(fid, prompt_flag,
			"-i", i_pstr, &(vmcdilate->i_file))
))
	{
	    if (prompt_flag == TRUE)
	    {
		while(!(vmcdilate->i_flag))
		{
		    fprintf(stderr, "\t\ti is required, please re-enter: \n");
		    vmcdilate->i_flag = vget_infile(fid, prompt_flag,
		    "-i", i_pstr, &(vmcdilate->i_file))
;

		}
	    }
	    else
	    {
		fprintf(stderr, "Error: '-i' is a required argument\n");
		gw_usage();
		exit(1);
	    }
	}

	if (!(vmcdilate->k_flag = vget_infile(fid, prompt_flag,
			"-k", k_pstr, &(vmcdilate->k_file))
))
	{
	    if (prompt_flag == TRUE)
	    {
		while(!(vmcdilate->k_flag))
		{
		    fprintf(stderr, "\t\tk is required, please re-enter: \n");
		    vmcdilate->k_flag = vget_infile(fid, prompt_flag,
		    "-k", k_pstr, &(vmcdilate->k_file))
;

		}
	    }
	    else
	    {
		fprintf(stderr, "Error: '-k' is a required argument\n");
		gw_usage();
		exit(1);
	    }
	}

	if (!(vmcdilate->o_flag = vget_outfile(fid, prompt_flag,
			"-o", o_pstr, &(vmcdilate->o_file))
))
	{
	    if (prompt_flag == TRUE)
	    {
		while(!(vmcdilate->o_flag))
		{
		    fprintf(stderr, "\t\to is required, please re-enter: \n");
		    vmcdilate->o_flag = vget_outfile(fid, prompt_flag,
		    "-o", o_pstr, &(vmcdilate->o_file))
;

		}
	    }
	    else
	    {
		fprintf(stderr, "Error: '-o' is a required argument\n");
		gw_usage();
		exit(1);
	    }
	}

	/*
	 * get optional arguments for vmcdilate
	 */
	if (prompt_flag == TRUE)
	   fprintf(stderr,"\nOptional Arguments:\n\n");

	vmcdilate->f_flag = vget_int(fid, prompt_flag,
	"-f", f_pstr, &(vmcdilate->f_int),
	255, 0, 255);

	vmcdilate->w_flag = vget_int(fid, prompt_flag,
	"-w", w_pstr, &(vmcdilate->w_int),
	255, 0, 255);


}



